
#define MAX_NUM_SUFFIX    16
#define MAX_SUFFIX_LEN    64

enum entry_status {
     STATUS_UNKNOWN,
     IS_SERVER,
     HAS_SUFFIXES,
     HAS_NO_SUFFIXES,
     HAS_CHILDREN,
     HAS_NO_CHILDREN
};

struct node_entry {
     enum entry_status status;
     char *dn;
     /* cache values here */
};



GtkWidget *create_mainwin_browsemode(void);
void add_all_servers(void);
GtkWidget *gnode_to_tree(GNode *node, GtkWidget *tree);
void remove_server_node_tree(struct ldapserver *server);
gboolean gnode_to_tree_callback(GNode *node, gpointer tree);

void attach_children_to_node(GtkWidget *item);
void attach_children_to_tree(GtkWidget *item);
void attach_server_suffixes(GtkWidget *item);

void server_item_selected(GtkWidget *treeroot, GtkWidget *item);
void tree_item_selected(GtkWidget *treeroot, GtkWidget *item);

void descend_onelevel(GNode *node);
struct ldapserver *server_by_node(GNode *node);

struct node_entry *new_node_entry(char *dn);
char *dn_by_node(GNode *node);

void get_suffix(struct ldapserver *server, char suffix[MAX_NUM_SUFFIX][MAX_SUFFIX_LEN]);

void free_browse_all(void);
gboolean node_entry_free_callback(GNode *node, gpointer dummy);


