#include <lber.h>
#include <ldap.h>

#define MAX_SERVERNAME_LEN    32
#define MAX_HOSTNAME_LEN      64

#define MAX_NUM_ATTRIBUTES   128
#define MAX_DN_LEN           128
#define MAX_ATTR_LEN          64
#define MAX_BINDPW_LEN        32

#define DEFAULT_SHOWDN         1
#define DEFAULT_SHOWOC         1


#define SEARCHARG_BEGINS_WITH    0
#define SEARCHARG_ENDS_WITH      1
#define SEARCHARG_CONTAINS       2
#define SEARCHARG_EQUALS         3



struct ldapserver {
     char name[MAX_SERVERNAME_LEN];
     char ldaphost[MAX_HOSTNAME_LEN];
     int ldapport;
     char basedn[MAX_DN_LEN];
     char binddn[MAX_DN_LEN];
     char bindpw[MAX_BINDPW_LEN];
     char searchattr[MAX_ATTR_LEN];
     int maxentries;
     int cacheconn;
     LDAP *connection;

     struct ldapserver *next;
};

