#include <stdio.h>

#include "debug.h"
#include "configfile.h"
#include "common.h"

int num_mallocs = 0;
int max_mallocs = 0;

extern struct gq_config config;


void *gq_malloc(size_t size, char *msg)
{

     void *newmem;

     newmem = malloc(size);
     printf("+ gq_malloc: %s (%d bytes @ 0x%x)\n", msg, size,
	    (unsigned int) newmem);

     num_mallocs++;
     max_mallocs++;

     return(newmem);
}


void gq_free(void *mem, char *msg)
{

     printf("- gq_free: %s (0x%x)\n", msg, (unsigned int) mem);
     num_mallocs--;

     free(mem);

}


void report_num_mallocs(void)
{

     printf("==============================================\n");
     printf("Total number of mallocs: %d\n", max_mallocs);
     printf("Number of mallocs left : %d\n", num_mallocs);

     if(num_mallocs)
	  printf("memory allocation mismatch: %d allocations left\n",
		 num_mallocs);

}


void dump_ldapservers(void)
{
     struct ldapserver *server;
     int i;

     i = 1;
     server = config.ldapservers;
     while(server) {
	  printf("server %d: %s\n", i, server->name);
	  server = server->next;
	  i++;
     }

}



